/**
 * 就业服务
 */

import { systemConfig } from "../config/serverConfig";
import { jyfwPopTableData, jyfwTableData, qwZdgzrqTableData } from "../data/table/tableData";
import { keyValuePackage, onceYBarChartPackage, stringListPackage, tablePackage } from "../dataPackage/inFrontOut";
import { getKeyValueOut, getOnceYBarChartOut, getStringOut } from "../dataPackage/out";
import { getConfData, getOneChange } from "../dataPackage/public";
import { findImageOrFolderImages, findVideoOrFolderImages, readFileList } from "../dataPackage/tool";
import { successResult } from "../tools/systemTools";
const { execSync } = require('child_process');
const path = require('path');

/**
 * 主界面
 * @param req 
 * @param res 
 */
export function getData(req, res) {
    let excelData = jyfwTableData();

    let ret:any = {};

    /**左屏 */
    let jcgkPackageData = keyValuePackage(excelData['基础概况'].dataList);
    ret['jcgk'] = getKeyValueOut('基础概况', jcgkPackageData);

    let xbfxPackageData = keyValuePackage(excelData['性别分析'].dataList);
    ret['xbfx'] = getKeyValueOut('性别分析', xbfxPackageData);

    let nlfbPackageData = keyValuePackage(excelData['年龄分布'].dataList);
    ret['nlfb'] = getKeyValueOut('年龄分布', nlfbPackageData);

    let xlfbPackageData = keyValuePackage(excelData['学历分布'].dataList);
    ret['xlfb'] = getKeyValueOut('学历分布', xlfbPackageData);

    let swyryqkfxPackageData = keyValuePackage(excelData['失无业人员情况分析'].dataList);
    ret['swyryqkfx'] = getKeyValueOut('失无业人员情况分析', swyryqkfxPackageData);

    let swyxbblPackageData = keyValuePackage(excelData['失无业人员性别比例'].dataList);
    ret['swyxbbl'] = getKeyValueOut('性别比例', swyxbblPackageData);

    let swynlfbPackageData = keyValuePackage(excelData['失无业人员年龄分布'].dataList);
    ret['swynlfb'] = getKeyValueOut('年龄分布（周岁）', swynlfbPackageData);

    let swyqkqsChartPackage = onceYBarChartPackage(excelData['失无业人员服务成效'], '月');
    ret['swyqkqs'] = getOnceYBarChartOut('失无业人员服务成效', swyqkqsChartPackage);

    /**中屏 */
    let ztsjPackageData = keyValuePackage(excelData['整体数据'].dataList);
    ret['ztsj'] = getKeyValueOut('整体数据', ztsjPackageData);

    let xxbbPackageData = stringListPackage(excelData['信息播报'].dataList);
    ret['xxbb'] = getStringOut('信息播报', xxbbPackageData);

    let fwzyPackageData = keyValuePackage(excelData['服务资源'].dataList);
    ret['fwzy'] = getKeyValueOut('服务资源', fwzyPackageData);

    let hphxyyPackageData = keyValuePackage(excelData['湖畔汇·享业苑'].dataList);
    let hphxyyData = [];
    hphxyyPackageData.forEach( info => {
        let {key, value} = info;
        let imgData = readFileList(`img/湖畔汇/${key}/`, [], "jpg");
        hphxyyData.push({key, value, img:imgData});
    })
    ret['hphxyy'] = {title:'湖畔汇·享业苑', dataList:hphxyyData};

    /**右屏 */
    let jyfwPackageData = keyValuePackage(excelData['就业服务'].dataList);
    ret['jyfw'] = getKeyValueOut('就业服务', jyfwPackageData);

    let cyfwPackageData = keyValuePackage(excelData['创业服务'].dataList);
    ret['cyfw'] = getKeyValueOut('创业服务', cyfwPackageData);

    let pxfwTableList = tablePackage(excelData['培训服务'].headerList[0], excelData['培训服务'].bodyList);
    ret['pxfw'] = {title:'培训服务', dataList:pxfwTableList};
    
    let jcybtffqkChartPackage = onceYBarChartPackage(excelData['南汇新城镇就创业补贴发放情况'], '');
    ret['jcybtffqk'] = getOnceYBarChartOut('南汇新城镇就创业补贴发放情况', jcybtffqkChartPackage);

    let lggwTableList = tablePackage(excelData['零工岗位'].headerList[0], excelData['零工岗位'].bodyList);
    ret['lggw'] = {title:'零工岗位', dataList:lggwTableList};

    res.send(ret);
}


/**
 * 就业服务弹窗
 * @param req 
 * @param res 
 */
export function getPopData(req, res) {
    let name = req.query.name || "滴水湖馨苑二居委";
    let ret:any = {};

    let excelData = jyfwPopTableData();
    
    let jyfwDataList = excelData["村居委数据采集汇总"].dataList;

    let jyfwNewConf = ["名称", "就业年龄段户籍人数", "无业人数", "失业人数", "图片视频类型", "姓名", "服务年限", "服务电话", "工作格言", "保障员所获荣誉"];
    let jyfwData = getOneChange(excelData["村居委数据采集汇总"].titleList, jyfwNewConf, jyfwDataList, name, "mc");

    let nameConf = ["名称", "图片视频类型"];
    let nameData = getConfData(nameConf, jyfwData);
    // let imgData = `${systemConfig.ipUrl}村居委/${name}.jpg`;
    let imgData = [];
    if (nameData[1].value == "图片") imgData = findImageOrFolderImages(name, `img/村居委/`);
    else imgData = findVideoOrFolderImages(name, `img/村居委/`);
    nameData.push({key:"地址", value:imgData});
    ret["nameData"] = {title:"图片数据", dataList:nameData};

    let jwgkConf = ["就业年龄段户籍人数", "无业人数", "失业人数"];
    let jwgkData = getConfData(jwgkConf, jyfwData);
    ret["jwgk"] = {title:"居委概括", dataList:jwgkData};

    let jybzyConf = ["姓名", "服务年限", "服务电话", "工作格言", "保障员所获荣誉"];
    let jybzyData = getConfData(jybzyConf, jyfwData);

    let jybzy = jybzyData;
    let bzyImg = "";
    jybzyData.forEach( info => {
        let {key, value} = info;
        if (key == "姓名") {
            bzyImg = `${systemConfig.ipUrl}保障员/${value}.jpg`;
            jybzy.push({key:"照片", value:bzyImg});
        }
    })
    ret["jybzy"] = {title:"就业保障员", dataList:jybzy};

    let zdgzrqConf = ["长期失业青年", "应届毕业生", "新退工人员", "就业困难人员"];
    ret["zdgzry"] = qwZdgzrqTableData(zdgzrqConf, name);

    res.send(ret);
}


/**
 * 启动微信小程序的bat文件
 * @returns 
 */
export function runBat(req, res) {
    let ret:any = {};
    
    let batPash = path.join(__dirname.substring(0,__dirname.indexOf("out")), "res", 'weixin.bat' );
    try {
        execSync(`cmd /c "${batPash}"`, { stdio: 'inherit' });
        console.log('Batch file executed successfully');
    } catch (error) {
        console.error('Error executing batch file:', error);
    }

    ret = successResult();
    
    res.send(ret);
}






