//excel 和 接口都可以使用的格式化数据的方法

import { separateDataAndUint } from "./tool";

/**
 * objBecomeOfList  对象变成数组  value不限制类型
 * @param obj 对象 {"key1":"value1", "key2":"value2"}
 * @param keyName 指定key的名称 默认 name
 * @param valueName 指定value的名称  默认 data
 * @returns [{name:"key1", "data":"value1"}, ...]
 */
export function objBecomeOfList(obj, keyName="name", valueName="data") {
    let result = [];
    for (let key in obj) {
        let once:any = {};
        once[keyName] = key;
        once[valueName] = obj[key];
        result.push(once);
    }
    return result;
}

/**
 * objChangeKey  obj改变key
 * @param obj {"key1":"value1", "key2":"value2"}
 * @param checkKeyInfo {"key1":"eKey1", "key2":"eKey2"}
 * @returns  
 */
export function objChangeKey(obj, checkKeyInfo) {
    let result = {};
    for (let key in obj) {
        let newKey = checkKeyInfo[key] || key;
        result[newKey] = obj[key];
    }
    return result;
}


/**
 * objListChangeKey  objList 改变key
 * @param objList 
 * @param checkKeyInfo 
 * @returns 
 */
export function objListChangeKey(objList, checkKeyInfo) {
    return 
}


/**
 * 获取参数弹窗数据结构修改
 * @param oldConf 表格数据原本的key
 * @param newConf 需要修改成的中文key 
 * @param dataList 表格数据
 * @param name 匹配数据的参数
 * @param subName 参数匹配数据的字段key
 * @param isNum 是否数字类型
 * @returns [{key:"", value:""}, {}]
 */
 export function getOneChange(oldConf, newConf, dataList, name?, subName?, isNum?) {
    let reg = new RegExp(name);

    let data = [];
    dataList.forEach( info => {
        if (reg.test(info[subName])) {
            for (let i = 0; i < newConf.length; i++) {
                let value = info[oldConf[i]];
                let {dataNum, dataUnit} = separateDataAndUint(value);
                
                let analysisValue;
                if (isNaN(dataNum) || dataUnit == value){
                    analysisValue = value;
                } else {
                    analysisValue = dataNum;
                }
                data.push({
                    key: newConf[i],
                    value: analysisValue
                })
            }
        }
    })

    return data;
}


/**
 * 获取指定key数据
 * @param conf 
 * @param dataList 
 * @returns 
 */
export function getConfData(conf, dataList) {
    let data = [];

    for (let i = 0; i < conf.length; i++) {
        dataList.forEach( info => {
            let {key, value} = info;
            if (key == conf[i]) data.push(info);
        })
    }

    return data;
}





