
import * as crypto from 'crypto';

/**
 * 加密
 * @param text 要加密的明文
 * @param key 密码
 * @param iv 偏移量
 * key和iv都应为16字节长
 * @returns 
 */
export function encrypt(text, key, iv) {
    let cipher = crypto.createCipheriv('aes-128-cbc', key, iv);
    let encrypted = cipher.update(text, 'utf8', 'base64');
    encrypted += cipher.final('base64');
    return encrypted;
}



/**
 * 解密
 * @param encrypted 要解密的密文
 * @param key 密码
 * @param iv 偏移量
 * key和iv都应为16字节长
 * @returns 
 */
export function decrypt(encrypted, key, iv) {
    let decipher = crypto.createDecipheriv('aes-128-cbc', key, iv);
    let decrypted = decipher.update(encrypted, 'base64', 'utf8');
    decrypted += decipher.final('utf8');
    return decrypted;
}

