/**
 * 总路由入口
 */

import * as asyncHandler from 'express-async-handler';
import * as mapBiz from '../biz/map';
import * as jyfwBiz from '../biz/jyfw';
import * as jzfwBiz from '../biz/jzfw';
import * as queryMachineBiz from '../biz/queryMachine';


export function setRouter(httpServer){
    /**大屏 */
    httpServer.get('/jyfw', asyncHandler(jyfwBiz.getData));
    httpServer.get('/jyfw/map', asyncHandler(mapBiz.getJyMap));
    httpServer.get('/jyfw/pop', asyncHandler(jyfwBiz.getPopData));
    
    httpServer.post('/jyfw', asyncHandler(jyfwBiz.getData));
    httpServer.post('/jyfw/map', asyncHandler(mapBiz.getJyMap));
    httpServer.post('/jyfw/pop', asyncHandler(jyfwBiz.getPopData));

    httpServer.get('/jyfw/runbat', asyncHandler(jyfwBiz.runBat));

    httpServer.get('/jzfw/map', asyncHandler(mapBiz.getJzMap));
    httpServer.get('/jzfw', asyncHandler(jzfwBiz.getData));
    httpServer.get('/jzfw/pop', asyncHandler(jzfwBiz.getPopData));

    httpServer.post('/jzfw/map', asyncHandler(mapBiz.getJzMap));
    httpServer.post('/jzfw', asyncHandler(jzfwBiz.getData));
    httpServer.post('/jzfw/pop', asyncHandler(jzfwBiz.getPopData));

    httpServer.get('/pop', asyncHandler(mapBiz.getPop));


    /**查询机 */
    httpServer.get('/querymachine/qwscreen', asyncHandler(queryMachineBiz.getQWScreen));
    httpServer.get('/querymachine/list', asyncHandler(queryMachineBiz.getLargeScreen));
    httpServer.get('/querymachine/detailed', asyncHandler(queryMachineBiz.getJobDetailed));
    httpServer.get('/querymachine/policy', asyncHandler(queryMachineBiz.getPolicy));

    httpServer.post('/querymachine/qwscreen', asyncHandler(queryMachineBiz.getQWScreen));
    httpServer.post('/querymachine/list', asyncHandler(queryMachineBiz.getLargeScreen));
    httpServer.post('/querymachine/detailed', asyncHandler(queryMachineBiz.getJobDetailed));
    httpServer.post('/querymachine/policy', asyncHandler(queryMachineBiz.getPolicy));

}

